# -*- coding: utf-8 -*-
"""
Created on Fri Feb 24 20:48:36 2023

This function will calculate slope and roughness of input raster.

@author: Elias Adediran
"""


from osgeo import gdal
import matplotlib.pyplot as plt


# Define a function for calculating DEM slope
def cal_slope(input_dataset,output_name):
    input_dataset = gdal.Open(input_dataset)
    slp = gdal.DEMProcessing(output_name, input_dataset, "slope",  computeEdges=True)
    slp_Array = slp.GetRasterBand(1).ReadAsArray()
    return slp_Array
    slp = None

    # with gdal.Open(input_dataset) as dataset:
    #     slp = gdal.DEMProcessing(output_name, dataset, "slope", computeEdges=True)
    #     slp_Array = slp.GetRasterBand(1).ReadAsArray()
    #     return slp_Array

# Example of implementation
#lin_slope = cal_slope(lin_interp_tif,'lin_slope2.tif')


# Define a function for calculating DEM roughness
def cal_roughness(input_dataset,output_name):
    input_dataset = gdal.Open(input_dataset)
    rgn = gdal.DEMProcessing(output_name, input_dataset, "roughness",  computeEdges=True)
    rgn_Array = rgn.GetRasterBand(1).ReadAsArray()
    return rgn_Array
    rgn = None
    # with gdal.Open(input_dataset) as dataset:
    #     rgn = gdal.DEMProcessing(output_name, dataset, "roughness", computeEdges=True)
    #     rgn_Array = rgn.GetRasterBand(1).ReadAsArray()
    #     return rgn_Array
    
# lin_roughness = cal_roughness(lin_interp_tif,'lin_roughness.tif')
