import numpy as np
from scipy.ndimage import distance_transform_edt


def compute_proximity_distance(array, target_value):
    # Always set the target value to the no data value
    # Create a binary mask of the target pixels
    target_mask = np.where(array == target_value, 1, 0)

    # Compute the distance transform
    distance = distance_transform_edt(target_mask)

    return distance
